<?php

/**
 * @file bowob.php
 *
 * Implements main functions and calls the BoWoB API.
 */

$bowob_type = is_numeric(@$_GET['type']) ? intval($_GET['type']) : -1;

if($bowob_type == 2)
{
  bowob_server_sync();
}
elseif($bowob_type == 3)
{
  bowob_client_sync();
}
elseif($bowob_type == 4)
{
  bowob_redirect_login();
}
elseif($bowob_type == 5)
{
  bowob_redirect_profile();
}

/**
 * Prints synchronization data to be readed by BoWoB server.
 * @return void.
 */
function bowob_server_sync()
{
  header('Cache-Control: no-cache, must-revalidate');
  header('Content-Type: text/plain; charset=utf-8');

  include(dirname(realpath(__FILE__)) . '/bowob_api.php');

  echo bowob_api_get_sync_data(
    is_numeric(@$_GET['id']) ? intval($_GET['id']) : -1,
    is_string(@$_GET['sync']) ? $_GET['sync'] : '',
    @$_GET['name'] == '1',
    @$_GET['avatar'] == '1',
    @$_GET['friends'] == '1'
  );
}

/**
 * Creates a synchronization record and prints record identifiers to be readed by BoWoB client.
 * @return void.
 */
function bowob_client_sync()
{
  header('Cache-Control: no-cache, must-revalidate');
  header('Content-Type: text/plain');

  include(dirname(realpath(__FILE__)) . '/bowob_api.php');
  
  echo bowob_api_new_sync(
    is_string(@$_GET['nick']) ? $_GET['nick'] : '',
    @$_GET['name'] == '1',
    @$_GET['avatar'] == '1'
  );
}

/**
 * Redirects to login page.
 * @return void.
 */
function bowob_redirect_login()
{
  // TO COMPLETE
}

/**
 * Redirects to user profile page.
 * @return void.
 */
function bowob_redirect_profile()
{
  $userid = is_numeric(@$_GET['id']) ? intval($_GET['id']) : -1;

  // TO COMPLETE
}

/**
 * Prints BoWoB HTML code for show the chat.
 * @return void.
 */
function bowob_code()
{
  include(dirname(realpath(__FILE__)) . '/bowob_api.php');

  // TO COMPLETE

  echo bowob_api_get_code(/* BOWOB_APP_ID */, /* BOWOB_SERVER_ADDRESS */);
}

/**
 * Checks if current user is logued.
 * @return boolean User is logued.
 */
function bowob_is_user_logued()
{
  // TO COMPLETE
}

/**
 * Gets current user id.
 * @return int User id.
 */
function bowob_get_user_id()
{
  // TO COMPLETE
}

/**
 * Gets current user nick.
 * @return string User nick.
 */
function bowob_get_user_nick()
{
  // TO COMPLETE
}

/**
 * Gets current user name.
 * @return string User name.
 */
function bowob_get_user_name()
{
  // TO COMPLETE
}

/**
 * Gets current user avatar url.
 * @return string User avatar.
 */
function bowob_get_user_avatar()
{
  // TO COMPLETE
}

/**
 * Gets current user friends.
 * @param int $id User id.
 * @param string $separator Separator between nicks.
 * @return string User friends.
 */
function bowob_get_user_friends($id, $separator)
{
  // TO COMPLETE
}

/**
 * Stores a synchronization record in database.
 * @param string $auth Record auth.
 * @param int $creation Record creation time.
 * @param int $user_id Record user id.
 * @param string $user_nick Record user nick.
 * @param string $user_name Record user name.
 * @param string $user_avatar Record user avatar.
 * @param int $user_type Record user type.
 * @return int Record id.
 */
function bowob_store_sync($auth, $creation, $user_id, $user_nick, $user_name, $user_avatar, $user_type)
{
  // TO COMPLETE
}

/**
 * Extracts a synchronization record from database.
 * @param int $id Record id.
 * @param string $auth Record auth.
 * @param int $expiration Record expiration time.
 * @return array Record values.
 */
function bowob_extract_sync($id, $auth, $expiration)
{
  // TO COMPLETE
}

?>
